/* Copyright (C) 2005 Hiroyuki OYAMA
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MC_TEMPLATE_H
#define MC_TEMPLATE_H

#include "apr_pools.h"
#include "apr_file_io.h"
#include "apr_strings.h"
#include "apr_general.h"
#include "apr_errno.h"

#define MC_TEMPLATE_VERSION "mc/template 0.0.1"

typedef struct mc_template_node {
    int type;
    const char *name;
    const char *arg1;
    const char *arg2;
    struct mc_template_node *next;
} mc_template_node_t;


typedef struct {
    const char *src;
    mc_template_node_t *nodes;
} mc_template_t;



mc_template_t *mc_template_create(apr_pool_t *p, const char *path);
mc_template_t *mc_template_create_by_string(apr_pool_t *p, const char *src);
const char *mc_template_build(apr_pool_t *p,
                              mc_template_t *tmpl, apr_table_t *param);

#endif /* !MC_TEMPLATE_H */
